# -*- coding: utf-8 -*-

#  PycaWM
#  wrappers.py
#  Copyright (c) 2007 Vincent Rasneur, Anaël Verrier

#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; version 3 only.

#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import sys

if sys.version_info < (2, 5):
    raise ImportError('wrappers module needs at least Python 2.5!')

class SocketWrapper(object):
    """Wraps a socket and a function to call when there is something to
    read in the socket."""
    def __init__(self, socket, fun):
        self.socket = socket
        self.do_stuff = fun

    def fileno(self):
        # we need this method if we want to keep the select (in the pycawm
        # event_loop) happy
        return self.socket.fileno()

class DisplayWrapper(SocketWrapper):
    """Wraps a display and a function to call when there is a pending event
    in the display. As displays have sockets too, inherit from SocketWrapper."""
    def __init__(self, display, fun):
        SocketWrapper.__init__(self, display, fun)

    def pending_events(self):
        # shortcut for the pycawm event_loop
        return self.socket.pending_events()
